package pwp;

public class Match {

    public enum Outcome {
        WIN,
        LOSS,
        DRAW;

        public static Outcome fromString(String s) {
            switch (s) {
                case "Win": return WIN;
                case "Loss": return LOSS;
                case "Draw": return DRAW;
                case "Bye": return WIN;

                default: throw new IllegalArgumentException("Must be 'Win', 'Loss', 'Draw', or 'Bye'");
            }
        }
    }

    private int round;
    private String opponent;
    private Outcome outcome;

    public int getRound() {
        return round;
    }

    public void setRound(int round) {
        this.round = round;
    }

    public String getOpponent() {
        return opponent;
    }

    public void setOpponent(String opponent) {
        this.opponent = opponent;
    }

    public Outcome getOutcome() {
        return outcome;
    }

    public void setOutcome(Outcome outcome) {
        this.outcome = outcome;
    }
}
