package pwp;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class ReportByFormat {

    private Map<String,List<Event>> eventsByFormat;

    public ReportByFormat(List<Event> events) {
        this.eventsByFormat = new LinkedHashMap<>();

        for (Event event : events) {
            String format = event.getFormat();

            if (eventsByFormat.get(format) == null) {
                eventsByFormat.put(format, new ArrayList<Event>());
            }

            eventsByFormat.get(format).add(event);
        }
    }

    public String toString() {
        StringBuilder sb = new StringBuilder();

        for (String format : eventsByFormat.keySet()) {
            Record formatRecord = Record.fromEvents(eventsByFormat.get(format));

            sb.append(format).append(":\n");
            sb.append("Overall record: ").append(formatRecord).append("\n");
            sb.append("Win percentage ignoring draws: ").append(formatRecord.winPercentageWithoutDraws()).append("\n");
            sb.append("Win percentage including draws: ").append(formatRecord.winPercentageWithDraws()).append("\n");
            sb.append("\n");
        }

        return sb.toString();
    }
}
