package pwp;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class ReportByType {

    private Map<String,List<Event>> eventsByType;

    public ReportByType(List<Event> events) {
        this.eventsByType = new LinkedHashMap<>();

        for (Event event : events) {
            String type = event.getType();

            if (eventsByType.get(type) == null) {
                eventsByType.put(type, new ArrayList<Event>());
            }

            eventsByType.get(type).add(event);
        }
    }

    public String toString() {
        StringBuilder sb = new StringBuilder();

        for (String type : eventsByType.keySet()) {
            Record typeRecord = Record.fromEvents(eventsByType.get(type));

            sb.append(type).append(":\n");
            sb.append("Overall record: ").append(typeRecord).append("\n");
            sb.append("Win percentage ignoring draws: ").append(typeRecord.winPercentageWithoutDraws()).append("\n");
            sb.append("Win percentage including draws: ").append(typeRecord.winPercentageWithDraws()).append("\n");
            sb.append("\n");
        }

        return sb.toString();
    }
}
